/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code allows you to experiment with the text widget's 
convenience functions. Place different convenience functions
in the buttonCB function. 
***************************************************************/

/* text_test.c */

#include <Xm/Xm.h>
#include <Xm/Text.h>
#include <Xm/Form.h>
#include <Xm/PushB.h>

XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;

Widget toplevel;
Widget text;
Widget button;
Widget form;

void buttonCB(w,client_data,call_data)
    Widget w;
    XtPointer client_data;
    XmPushButtonCallbackStruct *call_data;
/* called whenever pushbutton is clicked. */
{
    char *s;

    /* Change the contents of this function to test different 
      convenience functions. */

    /* print out cursorPosition and value string. */
    printf("%d\n",XmTextGetCursorPosition(text));
    s=XmTextGetString(text);
    printf("%s\n",s);
    XtFree(s);
}

void main(argc,argv)
    int argc;
    char *argv[];
{
    Arg al[10];
    int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,NULL,NULL,0);

    /* set window size. */
    ac=0;
    XtSetArg(al[ac],XmNheight,300); ac++;
    XtSetArg(al[ac],XmNwidth,300); ac++;
    XtSetValues(toplevel,al,ac);

    /* create a form to hold widgets */
    ac=0;
    form=XmCreateForm(toplevel,"form",al,ac);
    XtManageChild(form);    

    /* create a push button */
    ac=0;
    XtSetArg(al[ac],XmNlabelString,
        XmStringCreate("Push to test",char_set)); ac++;
    XtSetArg(al[ac], XmNtopAttachment,    XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNleftAttachment,   XmATTACH_FORM); ac++;
    button=XmCreatePushButton(form,"button",al,ac);
    XtManageChild(button);
    XtAddCallback(button,XmNactivateCallback,buttonCB,NULL);

    /* create a text widget. */
    ac=0;
    XtSetArg(al[ac], XmNtopAttachment,    XmATTACH_WIDGET); ac++;
    XtSetArg(al[ac], XmNtopWidget, button); ac++;
    XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNleftAttachment,   XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNbottomAttachment,   XmATTACH_FORM); ac++;
    XtSetArg(al[ac],XmNeditMode,XmMULTI_LINE_EDIT); ac++; 
    text=XmCreateText(form,"text",al,ac); 
    XtManageChild(text);    

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
