/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates the use of a clip mask.
***************************************************************/

/* clip.c */

#include <Xm/Xm.h>
#include <Xm/DrawingA.h>
#include "circle.xbm"

XtAppContext context;

Widget toplevel;
Widget drawing_area;
GC gc;
int foreground,background;

void setup_gc()
/* set up the graphics context. */
{
    Arg al[10];
    int ac;
    XGCValues vals;
    Pixmap p;

    /* get the current fg and bg colors. */
    ac=0;
    XtSetArg(al[ac], XmNforeground, &foreground); ac++;
    XtSetArg(al[ac], XmNbackground, &background); ac++;
    XtGetValues(drawing_area, al, ac);

    p=XCreateBitmapFromData(XtDisplay(toplevel),
        RootWindowOfScreen(XtScreen(toplevel)),
        circle_bits,circle_width,circle_height);

    /* create the gc. */
    vals.foreground = foreground;
    vals.background = background;
    vals.clip_mask=p;
    vals.clip_x_origin=0;
    vals.clip_y_origin=0;
    gc= XCreateGC(XtDisplay(toplevel), 
        RootWindowOfScreen(XtScreen(toplevel)), 
        GCForeground | GCBackground | GCClipMask |
        GCClipXOrigin | GCClipYOrigin, &vals);
}

void exposeCB(w,client_data,call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
/* handles the exposure event */
{
    int x;

    for (x=0; x<100; x+=3)
        XDrawLine(XtDisplay(drawing_area), XtWindow(drawing_area), gc,
            x,0,x,100); 

}

void main(argc,argv)
    int argc;
    char *argv[];
{
    Arg al[10];
    int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,
        NULL,NULL,0);

    /* default window size. */
    ac=0;
    XtSetArg(al[ac],XmNheight,100); ac++;
    XtSetArg(al[ac],XmNwidth,100); ac++;
    XtSetValues(toplevel,al,ac);

    /* create drawing area */
    ac=0;
    drawing_area=XmCreateDrawingArea(toplevel,"drawing_area",al,ac);
    XtManageChild(drawing_area);
    /* add in event handlers for drawing area */
    XtAddCallback(drawing_area, XmNexposeCallback, exposeCB, NULL);

    setup_gc();

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
