/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates a celsius to fahrenheit converter
program implemented using four widgets attached to a
form.
***************************************************************/

/* c2f.form.c */

#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/Label.h>
#include <Xm/Scale.h>
#include <Xm/Separator.h>
#include <Xm/Form.h>

XtAppContext context;
XmStringCharSet char_set=XmSTRING_DEFAULT_CHARSET;

Widget toplevel, button, form, label, scale, sep;

void buttonCB(w, client_data, call_data)
    Widget w;
    int client_data;
    XmPushButtonCallbackStruct *call_data;
/* handles the pushbutton's activate callback. */
{
    exit(0);
}

void scaleCB(w, client_data, call_data)
    Widget w;
    int client_data;
    XmScaleCallbackStruct *call_data;
/* handles the scale's callback. */
{
    char s[100];
    Arg al[10];
    int ac;

    sprintf(s,"farenheit=%d",call_data->value*9/5+32);
    ac=0;
    XtSetArg(al[ac],XmNlabelString,
        XmStringCreate(s,char_set)); ac++;
    XtSetValues(label,al,ac);
}

void main(argc,argv)
    int argc;
    char *argv[];
{
    Arg al[10];
    int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,NULL,NULL,0);

    /* resize toplevel */
    ac=0;
    XtSetArg(al[ac],XmNheight,300); ac++;
    XtSetArg(al[ac],XmNwidth,200); ac++;
    XtSetValues(toplevel,al,ac);

    /* create a form to hold the other widgets */
    ac=0;
    form=XmCreateForm(toplevel,"form",al,ac);
    XtManageChild(form);

    /* create a push button */
    ac=0;
    XtSetArg(al[ac],XmNlabelString,
        XmStringCreate("Quit",char_set)); ac++;
    button=XmCreatePushButton(form,"button",al,ac);
    XtManageChild(button);
    XtAddCallback(button,XmNactivateCallback,buttonCB,NULL);

    /* create a scale */
    ac=0;
    XtSetArg(al[ac],XmNtitleString,
        XmStringCreate("Celsius Temperature",char_set)); ac++;
    XtSetArg(al[ac],XmNorientation,XmHORIZONTAL); ac++;
    XtSetArg(al[ac],XmNshowValue,True); ac++;
    scale=XmCreateScale(form,"scale",al,ac);
    XtManageChild(scale);
    XtAddCallback(scale,XmNdragCallback,scaleCB,NULL);

    /* create a label */
    ac=0;
    XtSetArg(al[ac],XmNlabelString,
        XmStringCreate("Farenheit = 32",char_set)); ac++;
    label=XmCreateLabel(form,"label",al,ac);
    XtManageChild(label);

    /* create a separator */
    ac=0;
    sep=XmCreateSeparator(form,"sep",al,ac);
    XtManageChild(sep);

    /* attach the children to the form */
    ac=0;
    XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_POSITION); ac++;
    XtSetArg(al[ac], XmNbottomPosition, 30); ac++; /* 30 is a percentage */
    XtSetValues(button,al,ac);

    ac=0;
    XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(al[ac], XmNtopWidget, button); ac++;
    XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetValues(scale,al,ac);

    ac=0;
    XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(al[ac], XmNtopWidget, scale); ac++;
    XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
    XtSetValues(sep,al,ac);

    ac=0;
    XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET); ac++;
    XtSetArg(al[ac], XmNtopWidget, sep); ac++;
    XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetValues(label,al,ac);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
